Bug 26304 - System.ArgumentNullException thrown when moving items in an ObservableCollection that is observed by a ListView.
Summary: System.ArgumentNullException thrown when moving items in an ObservableCollect...
Status: VERIFIED FIXED
Alias: None
Product: Forms
Classification: Xamarin
Component: Forms (show other bugs)
Version: 1.3.1
Hardware: PC Windows
: Normal normal
Target Milestone: 1.3.3
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2015-01-22 16:34 UTC by Jon Goldberger [MSFT]
Modified: 2015-02-04 09:07 UTC (History)
7 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on Developer Community or GitHub with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
VERIFIED FIXED

Description Jon Goldberger [MSFT] 2015-01-22 16:34:14 UTC
## Description

Moving an item down in a ListView with an ObservableCollection so that it goes off screen and then moving it back up will cause a
> System.ArgumentNullException Argument cannot be null. Parameter name: item
exception to be thrown.

## Steps to reproduce:

1. Open the attached test project (I used Visual Studio to match the customer's environment)
2. Restore packages
3. Set the Android project as the startup project.
4. Launch the app to a device or simulator (Tested on Xamarin Android Player Nexus 4 KitKat simulator)
5. Select an item in the list and click the "Move Down" button until the item is off the screen and then click the "Move Down" button one more time (so that it is off the screen by two places)
6. Click the "Move Up" button"

Expected result: Item will be moved back up one (but still would be off screen).

Actual result: Exception is thrown.

## Notes:

I added debug statements to verify that all of the items involved in the move are present and they are. The crash seems to be internal to Xamarin Forms.

## Stack Trace:

>System.ArgumentNullException Argument cannot be null. Parameter name: item

>  at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].GetIndex (Xamarin.Forms.Cell item) [0x00000] in <filename unknown>:0 
01-22 01:26:29.756 I/mono-stdout( 3929):   at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].GetIndex (Xamarin.Forms.Cell item) [0x00000] in <filename unknown>:0 

>  at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].OnProxyCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e, Boolean fixWindows) [0x00000] in <filename unknown>:0 
01-22 01:26:29.756 I/mono-stdout( 3929):   at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].OnProxyCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e, Boolean fixWindows) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].OnProxyCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.ListProxy.OnCollectionChanged (System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
01-22 01:26:29.756 I/mono-stdout( 3929):   at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].OnProxyCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.ListProxy+<>c__DisplayClassc.<OnCollectionChanged>b__8 () [0x00000] in <filename unknown>:0 
01-22 01:26:29.768 I/mono-stdout( 3929):   at Xamarin.Forms.ListProxy.OnCollectionChanged (System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
01-22 01:26:29.772 I/mono-stdout( 3929):   at Xamarin.Forms.ListProxy+<>c__DisplayClassc.<OnCollectionChanged>b__8 () [0x00000] in <filename unknown>:0 
01-22 01:26:29.772 I/mono-stdout( 3929):   at Xamarin.Forms.ListProxy.OnCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.ListProxy.OnCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at System.Collections.ObjectModel.ObservableCollection`1[System.String].OnCollectionChanged (System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at System.Collections.ObjectModel.ObservableCollection`1[System.String].MoveItem (Int32 oldIndex, Int32 newIndex) [0x00000] in <filename unknown>:0 
01-22 01:26:29.776 I/mono-stdout( 3929):   at System.Collections.ObjectModel.ObservableCollection`1[System.String].OnCollectionChanged (System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>   at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].GetIndex (Xamarin.Forms.Cell item) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].OnProxyCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e, Boolean fixWindows) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.TemplatedItemsList`2[Xamarin.Forms.ItemsView`1[Xamarin.Forms.Cell],Xamarin.Forms.Cell].OnProxyCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.ListProxy.OnCollectionChanged (System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.ListProxy+<>c__DisplayClassc.<OnCollectionChanged>b__8 () [0x00000] in <filename unknown>:0 
>  at Xamarin.Forms.ListProxy.OnCollectionChanged (System.Object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at System.Collections.ObjectModel.ObservableCollection`1[System.String].OnCollectionChanged (System.Collections.Specialized.NotifyCollectionChangedEventArgs e) [0x00000] in <filename unknown>:0 
>  at System.Collections.ObjectModel.ObservableCollection`1[System.String].MoveItem (Int32 oldIndex, Int32 newIndex) [0x00000] in <filename unknown>:0 
>  at System.Collections.ObjectModel.ObservableCollection`1[System.String].Move (Int32 oldIndex, Int32 newIndex) [0x00000] in <filename unknown>:0 
>  at ListViewMoveBug.App.MoveItem (Boolean up) [0x000e2] in c:\LongPath\ListViewMoveBug\ListViewMoveBug\ListViewMoveBug\App.cs:90 
01-22 01:26:29.776 I/mono-stdout( 3929):   at System.Collections.ObjectModel.ObservableCollection`1[System.String].MoveItem (Int32 oldIndex, Int32 newIndex) [0x00000] in <filename unknown>:0 
01-22 01:26:29.780 I/mono-stdout( 3929):   at System.Collections.ObjectModel.ObservableCollection`1[System.String].Move (Int32 oldIndex, Int32 newIndex) [0x00000] in <filename unknown>:0 
>  at System.Collections.ObjectModel.ObservableCollection`1[System.String].Move (Int32 oldIndex, Int32 newIndex) [0x00000] in <filename unknown>:0 
>  at ListViewMoveBug.App.MoveItem (Boolean up) [0x000e2] in c:\LongPath\ListViewMoveBug\ListViewMoveBug\ListViewMoveBug\App.cs:90 
01-22 01:26:29.784 I/mono-stdout( 3929):   at ListViewMoveBug.App.MoveItem (Boolean up) [0x000e2] in c:\LongPath\ListViewMoveBug\ListViewMoveBug\ListViewMoveBug\App.cs:90
Comment 3 Sadik Ali 2015-01-23 06:22:56 UTC
I have checked this issue and able to reproduce this. To reproduce this issue I have followed the steps and instruction provided in bug description.

When I select an item in the list and click the "Move Down" button until the item is off the screen and then click the "Move Down" button one more times so that it is off the screen by two places, now  click the "Move Up" "Button", observed that following exception:

"System.ArgumentNullException: Argument cannot be null. Parameter name: item"

Screencast:http://www.screencast.com/t/lu9RrCAdA

Vs Trace Logs: http://www.screencast.com/t/5SzTJ6DUUJo
Device Log: https://gist.github.com/Rajneesh360Logica/ad5dac653c81a7f0b205
Application Output: https://gist.github.com/Rajneesh360Logica/3e016a813238aabf2469

Environment Info:

Xamarin.Forms:1.3.2.6299-pre1

Microsoft Visual Studio Professional 2013
Version 12.0.30723.00 Update 3
Microsoft .NET Framework
Version 4.5.50938

Installed Version: Professional

LightSwitch for Visual Studio 2013   06177-004-0446016-02381
Microsoft LightSwitch for Visual Studio 2013

Team Explorer for Visual Studio 2013   06177-004-0446016-02381
Microsoft Team Explorer for Visual Studio 2013

Visual Basic 2013   06177-004-0446016-02381
Microsoft Visual Basic 2013

Visual C# 2013   06177-004-0446016-02381
Microsoft Visual C# 2013

Visual C++ 2013   06177-004-0446016-02381
Microsoft Visual C++ 2013

Visual F# 2013   06177-004-0446016-02381
Microsoft Visual F# 2013

Visual Studio 2013 Code Analysis Spell Checker   06177-004-0446016-02381
Microsoft® Visual Studio® 2013 Code Analysis Spell Checker

Portions of International CorrectSpell™ spelling correction system © 1993 by Lernout & Hauspie Speech Products N.V. All rights reserved.

The American Heritage® Dictionary of the English Language, Third Edition Copyright © 1992 Houghton Mifflin Company. Electronic version licensed from Lernout & Hauspie Speech Products N.V. All rights reserved.

Windows Phone SDK 8.0 - ENU   06177-004-0446016-02381
Windows Phone SDK 8.0 - ENU

Application Insights Tools for Visual Studio Package   1.0
Application Insights Tools for Visual Studio

ASP.NET and Web Tools   12.3.50717.0
Microsoft Web Developer Tools contains the following components:
Support for creating and opening ASP.NET web projects
Browser Link: A communication channel between Visual Studio and browsers
Editor extensions for HTML, CSS, and JavaScript
Page Inspector: Inspection tool for ASP.NET web projects
Scaffolding: A framework for building and running code generators
Server Explorer extensions for Microsoft Azure Websites
Web publishing: Extensions for publishing ASP.NET web projects to hosting providers, on-premises servers, or Microsoft Azure

ASP.NET Web Frameworks and Tools 2012.2   4.1.21001.0
For additional information, visit http://go.microsoft.com/fwlink/?LinkID=309563

ASP.NET Web Frameworks and Tools 2013   5.2.20703.0
For additional information, visit http://www.asp.net/

Common Azure Tools   1.2
Provides common services for use by Azure Mobile Services and Microsoft Azure Tools.

Microsoft Advertising SDK for Windows Phone   
Microsoft Advertising SDK for Windows Phone
Build 

Microsoft Azure Mobile Services Tools   1.2
Microsoft Azure Mobile Services Tools

NuGet Package Manager   2.8.50926.663
NuGet Package Manager in Visual Studio. For more information about NuGet, visit http://docs.nuget.org/.

Office Developer Tools for Visual Studio 2013 ENU   12.0.30626
Microsoft Office Developer Tools for Visual Studio 2013 ENU

PowerShell Tools   1.2
Provides file classification services using PowerShell

PreEmptive Analytics Visualizer   1.2
Microsoft Visual Studio extension to visualize aggregated summaries from the PreEmptive Analytics product.

SQL Server Data Tools   12.0.30919.1
Microsoft SQL Server Data Tools

Windows Phone 8.1 SDK Integration   1.0
This package integrates the tools for the Windows Phone 8.1 SDK into the menus and controls of Visual Studio.

Workflow Manager Tools 1.0   1.0
This package contains the necessary Visual Studio integration components for Workflow Manager.

Xamarin   3.9.236.0 (d6a2cae)
Visual Studio extension to enable development for Xamarin.iOS and Xamarin.Android.

Xamarin.Android   4.20.0.34 (49a04b966feb40dfdba49d57ba16249b66d606a6)
Visual Studio plugin to enable development for Xamarin.Android.

Xamarin.iOS   8.6.0.0 (eb24bdcf5cba2c12b673a07e0a8cce368b9563b3)
Visual Studio extension to enable development for Xamarin.iOS.

Xamarin.iOS Unified Migration   1.0
Automated migration for Xamarin iOS Classic projects to Unified
Comment 4 Jason Smith [MSFT] 2015-01-29 21:44:23 UTC
Should be fixed in 1.3.3-pre1
Comment 5 Ram Chandra 2015-02-04 09:07:09 UTC
I have checked this issue with following build:

Xamarin.Forms.1.3.3.6321-pre2

Windows 8.1 Pro
Microsoft Visual Studio Professional 2013
Version 12.0.30723.00 Update 3
Microsoft .NET Framework
Version 4.5.51641
Installed Version: Professional
Xamarin   3.9.291.0 (9f3e552)
Xamarin.Android   4.20.0.34 (49a04b966feb40dfdba49d57ba16249b66d606a6)
Xamarin.iOS   8.6.1.0 (3b3ef438017c7ecf486defa9e01567a5f2b3cb2a)
Xamarin.iOS Unified Migration   1.0

When I select any item from the view and tap the "Move Down" button until the selected item goes off the view and press the move button I observed that I am not getting any error or exception. Application is working fine and selected items comes on the view.

This issue has been fixed. Hence I am closing this issue.